<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\Util;
use HCM\Util\TkEntity;

class FpaParamferiasmEntity extends TkEntity
{

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;
    private $_paramFerias;
    private $_nrParamFeriasAnterior;
    
    public function __construct($entityManager, $hcmParameters) {
        parent::__construct(null, $entityManager);
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $this->hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $this->hcmParameters->getDtCompetencia();
        $this->_nrParamFeriasAnterior = -1;
    }

    public function getPercentualAdiantamento13Salario(){
        if (is_object($this->_paramFerias) === true) {
            return $this->_paramFerias->historico->getVrpeadiant13sal();
        }
    }

    public function getNrDiasFeriasProvisao(){
        if (is_object($this->_paramFerias) === true) {
            return $this->_paramFerias->historico->getNrdiasferiaprov();
        }
    }

    public function getPercentualProvisao(){
        if (is_object($this->_paramFerias) === true) {
            return $this->_paramFerias->historico->getVrpeprovisao();
        }
    }

    public function procuraParamFerias($nrParamFerias){
        if ($this->_nrParamFeriasAnterior !== $nrParamFerias) {
            $itens = $this->getItems();
            if (count($itens) === 0) {
                $this->_inicializaListaParametroFerias();
                $itens = $this->getItems();
            }

            foreach ($itens as $key => $item) {
                if ((int)$item->getNrparamferiasm() === (int)$nrParamFerias) {
                    $this->_paramFerias = $this->getItem($key);
                    break;
                }
            }
        }
    }

    private function _inicializaListaParametroFerias(){
            $itens = $this->entityManager->getRepository(Repositories::FPA_PARAMFERIASM)->retornaParametrosFerias(
                $this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia
            );
            if(count($itens)==0){
                throw new Exception('Não foi encontrado parâmetro de férias ou o mesmo está incorreto para a estrutura. Confira os parâmetros de estrutura.');
            }
            foreach ($itens as $item) {
                $this->addItem($item);
            }
    }

    public static function getByNrorg($nrorg) {
        $result = self::getEntityByWhere('NRORG = ?', array($nrorg));
        return $result;
    }

}

