CREATE OR REPLACE FUNCTION MODELO_DOCUMENTO_GNRE(
   P_MODDOCFISC  IN NOTAFISCAL.CDMODDOCFISC%TYPE,
   P_TPDOCUMENTO IN VARCHAR2) RETURN VARCHAR /*1- GNRE ONLINE; 2- DARJ/GNRE RIO DE JANEIRO */
AS
   V_CDMODDOCGNRE VARCHAR2(5);
BEGIN
   IF P_TPDOCUMENTO = '1' THEN
      V_CDMODDOCGNRE := CASE WHEN P_MODDOCFISC = '1B'
                             THEN '01' /*Nota Fiscal Avulsa*/
                             WHEN P_MODDOCFISC IN ('08','07','8B','57')
                             THEN '07' /*Conhecimento de Transporte Rodovirio*/
                             WHEN P_MODDOCFISC = '10'
                             THEN '08' /*Conhecimento de Transporte Areo*/
                             WHEN P_MODDOCFISC = '09'
                             THEN '20' /*Conhecimento de Transporte Aquavirio*/
                             ELSE '10' /*Nota Fiscal*/
                             END;
   ELSE
      IF P_TPDOCUMENTO = '2' THEN
          V_CDMODDOCGNRE := CASE WHEN P_MODDOCFISC IN ('06','21','22')
                                 THEN 'PD'   /*Processamento de Dados*/
                                 WHEN P_MODDOCFISC IN ('55','57','59','65')
                                 THEN 'NF-e' /*Nota Fiscal Eletrnica*/
                                 ELSE 'M'    /*Manual*/
                                 END;
      END IF;
   END IF;
   RETURN(V_CDMODDOCGNRE);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('MODELO_DOCUMENTO_GNRE','5.67.000'); END;
/